package scalaadaptive.core.functions

import scalaadaptive.api.grouping.Group
import scalaadaptive.core.runtime.performance.PerformanceProvider
import scalaadaptive.core.functions.identifiers.FunctionIdentifier

/**
  * Created by Petr Kubat on 5/27/17.
  *
  * Data describing a selection and invocation process.
  * Generated by the [[scalaadaptive.core.runtime.selection.AdaptiveSelector]] implementation.
  *
  * @param selectedFunction The function that was selected to run.
  * @param groupId The group that the input belongs to.
  * @param inputDescriptor The input descriptor of the input (or None in case the descriptor function is not defined).
  * @param performance The measured performance of different stages of the selection and invocation process.
  *
  */
class RunData(val selectedFunction: FunctionIdentifier,
              val groupId: Group,
              val inputDescriptor: Option[Long],
              val performance: PerformanceProvider)
